<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               :upload-error="uploadError"
               :upload-after="uploadAfter"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.winecase_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/custom/winecase";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "名称",
              prop: "name",
              rules: [{
                required: true,
                message: "请输入名称",
                trigger: "blur"
              }]
            },
            {
              label: "分类",
              prop: "categoryId",
              hide: true,
              rules: [{
                required: true,
                message: "请选择分类",
                trigger: "blur"
              }],
              type: 'select',
              props: {
                label: 'title',
                value: 'id'
              },
              dicUrl: '/api/mall/categoryinfo/getByParentId/0'
            },
            {
              label: "厂商",
              prop: "manufacturerId",
              type: "select",
              filterable: true,
              rules: [{
                required: true,
                message: "请选择厂商",
                trigger: "blur"
              }],
              props: {
                label: 'name',
                value: 'id'
              },
              dicUrl: '/api/custom/manufacturer/get'
            },
            {
              label: "图片",
              prop: "imageShow",
              addDisplay: false,
              viewDisplay: false,
              editDisplay: false,
              type: 'upload',
              listType: 'picture-img',
            },
            {
              label: "价格",
              prop: "price",
              rules: [{
                required: true,
                message: "请输入价格",
                trigger: "blur"
              }]
            },
            // {
            //   label: "默认数量",
            //   prop: "defaultNum",
            //   rules: [{
            //     required: true,
            //     message: "请输入价格",
            //     trigger: "blur"
            //   }]
            // },
            {
              label: "单位",
              prop: "unit",
              value: "套",
              rules: [{
                required: true,
                message: "请输入单位",
                trigger: "blur"
              }]
            },
            {
              label: "长",
              prop: "length",
            },
            {
              label: "宽",
              prop: "width",
            },
            {
              label: "高",
              prop: "high",
            },
            {
              label: "排序",
              prop: "sort",
              rules: [{
                required: true,
                message: "请输入排序",
                trigger: "blur"
              }]
            },
            {
              label: "状态",
              prop: "status",
              rules: [{
                required: true,
                message: "请输入状态",
                trigger: "blur"
              }],
              type: "select",
              dicUrl: "/api/blade-system/dict/dictionary?code=state",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
            },
            {
              label: '图片',
              prop: 'image',
              type: 'upload',
              listType: 'picture-img',
              loadText: '上传中，请稍等',
              accept: 'image/png, image/jpeg',
              fileSize: 500,
              tip: '只能上传jpg/png文件，且不超过500kb',
              span: 24,
              hide: true,
              propsHttp: {
                res: 'data',
                url: 'link',
              },
              action: "/api/blade-resource/oss/endpoint/put-file-attach"
            },
            {
              label: '平面图',
              prop: 'planUrl',
              type: 'upload',
              listType: 'picture-img',
              loadText: '上传中，请稍等',
              accept: 'image/png, image/jpeg, image/jpg',
              fileSize: 1024,
              tip: '只能上传jpg/png文件，且不超过1M',
              span: 24,
              hide: true,
              propsHttp: {
                res: 'data',
                url: 'link',
              },
              action: "/api/blade-resource/oss/endpoint/put-file-attach"
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.winecase_add, false),
          viewBtn: this.vaildData(this.permission.winecase_view, false),
          delBtn: this.vaildData(this.permission.winecase_delete, false),
          editBtn: this.vaildData(this.permission.winecase_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      uploadError(error, column) {
        this.$message.error('上传失败:' + error)
        console.log(error, column)
      },
      uploadAfter(res, done, loading,column) {
        console.log(res,column)
        done()
      },
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.data.forEach(e => {
            e.imageShow = e.image
          })
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
